#############################################################################
#        Winbond W89C33 802.11a/b/g WLAN Adapter Driver                     #
#                                                                           #
#      Copyright (C) 2002, 2005  Winbond Electronics Corp.                  #
#                                                                           #
#############################################################################

miniport driver :     	ver.1.3.02.1001
-------------------------------
New function:
- No update.

Enhance function:
- Shorten power on procedure period

Bug fix:
- No update.


miniport driver :     	ver.1.3.01.1001
-------------------------------
New function:
- No update.

Enhance function:
- Change the TXVGA parameter structure.About EEPROM TXVGA writing method,
   former method is mapping value firstly and then write , now we will write the value directly.

Bug fix:
- No update.


miniport driver :     	ver.1.2.99.1001
-------------------------------
New function:
- Add new RF W89C33RF242MP relative parameters and functions.

Enhance function:
- No update.

Bug fix:
- In 11g,Japan region,14 channel can not use OFDM rates(6M,9M,12M,24M,36M,48M,54Mbps).



miniport driver :     	ver.1.2.97.1001
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
-  NB can not wake up from s3/s4 continuous above 100 times.



miniport driver :     	ver.1.2.95.1001
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
-  Connection incorrect when an IBSS and an AP has same SSID.



miniport driver :     	ver.1.2.93.1001
-------------------------------
New function:
- No update.

Enhance function:
- Modify region table as follow:
static region_name_map regions[] =
{
	{ WLAN_REGION_EUROPE, "Channel 1-13,",	Europe_channel },
	{ WLAN_REGION_JAPAN,  "Channel 1-14,",	Japan_channel },
	{ WLAN_REGION_USA,    "Channel 1-11,",	USA_channel },
	{ WLAN_REGION_FRANCE, "Channel 10-13,",	France_channel },
	{ WLAN_REGION_SPAIN,  "Channel 10-11,",	Spain_channel },
	{ WLAN_REGION_ISRAEL, "Channel 3-9,",	Israel_channel },
    { WLAN_REGION_MAX,    0,        0 } // defined as a sentry
};

Bug fix:
-  No update.




miniport driver :     	ver.1.2.91.1001
-------------------------------
New function:
- No update.

Enhance function:
- Drv_initialize.c: change for LED setting read from EEPROM
  Hal_302.c: enlarge the eeprom size limit
  Phy_302.c :add protect for xtal trimming


Bug fix:
-  No update.




miniport driver :     	ver.1.2.89.1001
-------------------------------
New function:
- No update.

Enhance function:
- No update.

Bug fix:
- Hidden AP shows wrong status and non-SSID in UI when its status is connected
(current status is: if hidden ap disconnect, it shows non-SSID in site survey,
if hidden ap connected, its icon shows connected and shows correct SSID in site survey. )



miniport driver :     	ver.1.2.87.1001
-------------------------------
New function:
-  Add TX_THROUGHPUT,RX_THROUGHPUT,RF TYPE altogether three OIDs.

Enhance function:
- No update

Bug fix:
- No update



miniport driver :     	ver.1.2.85.1001
-------------------------------
New function:
-  No update

Enhance function:
- Merge HH code:update for read vco cal data from eeprom and update the RF register

Bug fix:
- No update



miniport driver :     	ver.1.2.83.1001
-------------------------------
New function:
-  No update

Enhance function:
- Merge HH code:1. add more txvga for 0.5db per setp for w89rf242;
                2. update w89rf242 BB register.


Bug fix:
- No update



miniport driver :     	ver.1.2.81.1001
-------------------------------
New function:
-  No update

Enhance function:
- Using Polling (bit 14) for Radio on/off control

Bug fix:
- No update


miniport driver :     	ver.1.2.79.1001
-------------------------------
New function:
-  No update

Enhance function:
- No update

Bug fix:
- Fixed the bug for AIROHA2230 repeat setting RF open in power led function,
  which will result in WHQL 2c_recevice_packets failure becasue received packet be
  less than qualified number.



miniport driver :     	ver.1.2.77.1001
-------------------------------
New function:
-  No update

Enhance function:
- No update

Bug fix:
- Can not show AP list when hardware radio off



miniport driver :     	ver.1.2.75.1001
-------------------------------
New function:
-  Connect to AP more quickly than before after hardware radio off

Enhance function:
- No update

Bug fix:
- No update


miniport driver :     	ver.1.2.73.1001
-------------------------------
New function:
-  No update

Enhance function:
- No update

Bug fix:
-  Merge HH code:1. update the BB/RF register setting
                 2. update the MAC register for w89rf242
                 3. open the power control




miniport driver :     	ver.1.2.71.1001
-------------------------------
New function:
-  No update

Enhance function:
- No update

Bug fix:
-  Merge HH code(Modify EEPROM size).




miniport driver :     	ver.1.2.69.1001
-------------------------------
New function:
-  No update

Enhance function:
- No update

Bug fix:
-  Merge HH code.




miniport driver :     	ver.1.2.67.1001
-------------------------------
New function:
- Modify AMD 64bit inf file to fit for 64bit OS.

Enhance function:
- No update

Bug fix:
-  Fixed AID bug in save the capability information, AID and supported rates.



miniport driver :     	ver.1.2.65.1001
-------------------------------
New function:
- No update

Enhance function:
- add low power mode for disable driver

Bug fix:
- Can't pass 4-way handshake in Linux because sometimes add capabilities information in
associate requset as thoug AP don't include capabilities information.


miniport driver :     	ver.1.2.63.1001
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
-  Merger HH code


miniport driver :     	ver.1.2.61.1000
-------------------------------
New function:
- No update

Enhance function:
- Merger HH code.

Bug fix:
-  Merger HH code.


miniport driver :     	ver.1.2.59.1000
-------------------------------
New function:
- No update

Enhance function:
- Set LED1 always to high to reslove cardbus NIC issue;
- Merger HH code.

Bug fix:
-  No update;


miniport driver :     	ver.1.2.57.1000
-------------------------------
New function:
- No update

Enhance function:
- No update;


Bug fix:
-  Fixed the bug of RF AL7230 receive disabled after connect to an AP;


miniport driver :     	ver.1.2.55.1000
-------------------------------
New function:
- No update

Enhance function:
- Support RF type AL7230;


Bug fix:
-  No update;



miniport driver :     	ver.1.2.53.1000
-------------------------------
New function:
- No update

Enhance function:
- reduce active scan time


Bug fix:
- Modify some data for AL7230 RF


miniport driver :     	ver.1.2.51.1000
-------------------------------
New function:
- the code can support AMD64bit platform fro WINXP 64BIT EDITION
- support AL7230 RF

Enhance function:
- Merger AMD64bit and i386 use same source code
- Modify some BB date reference HH


Bug fix:
- Fix a bug about queryinformation


miniport driver :     	ver.1.2.49.1001
-------------------------------
New function:
- No update

Enhance function:
- Can set power on IBSS mode
- Start IBSS use short slot time
- Support WPA2 function

Bug fix:
- restore rf channel from reset hardware
- Fix a bug can't connect AP from sleep resume
- Fix a bug can't read eeprom at power_on_produce


miniport driver :     	ver.1.2.47.1001
-------------------------------
New function:
- No update

Enhance function:
- Support join hidden AP always .

Bug fix:
- No Update;


miniport driver :     	ver.1.2.45.1001
-------------------------------
New function:
- No update

Enhance function:
- Support hidden AP when AP is XG200 or DWL-7100G .

Bug fix:
- No Update;


miniport driver :     	ver.1.2.43.1001
-------------------------------
New function:
- No update

Enhance function:
- Connect hidden AP with John solution.

Bug fix:
- No update

miniport driver :     	ver.1.2.41.1001
-------------------------------
New function:
- No update

Enhance function:
- NIC will enable TX PIPELINE when send fragment packets
- Report false tx rate for Q-com issue
- Add ndis radio
- Enhance the ability of connect to hidden AP.

Bug fix:
- When change rate ,hibernate , when return to weindow , sometime the rate in status page and advance page are different ,now fixed.


miniport driver :     	ver.1.2.39.1001
-------------------------------
New function:
- No update

Enhance function:
- filter invaild deauth packet
- Add reset dma, reset hardware function on watch dog
- disable TX/RX pipe
- disable CRC fileter
- modify DXX register for ZCOM
- support hidden AP

Bug fix:
- fix a bug system will hangup when remove cardbus NIC


miniport driver :     	ver.1.2.37.1001
-------------------------------
New function:
- No update

Enhance function:
- No updated

Bug fix:
- Fix the bug that driver disabled MTO at the end of drv_initialize()


miniport driver :     	ver.1.2.35.1001
-------------------------------
New function:
- No update

Enhance function:
- Do power on procedure when join to any network, OID_802_11_SSID, and disconnect from an IBSS
- Call drv_reset() at the end of drv_initialize() (according to Join's suggestion)

Bug fix:
- No updated

miniport driver :     	ver.1.2.33.1001
-------------------------------
New function:
- No update

Enhance function:
- No updated

Bug fix:
- Fix the bug that driver doesn't return appropriate value when NDIS set OIDs with invalid data


miniport driver :     	ver.1.2.31.1001
-------------------------------
New function:
- No update

Enhance function:
- No updated

Bug fix:
- Fix the bug that driver doesn't indicate a disconnection event in IBSS when region changed

miniport driver :     	ver.1.2.29.1001
-------------------------------
New function:
- No update

Enhance function:
- Modify EEPROM ID offset refence eeprom conent 1.2 version
- Add some delay after _drv_power_on_procedure

Bug fix:
- - No update


miniport driver :     	ver.1.2.27.1001
-------------------------------
New function:
- No update

Enhance function:
- Filter all data packets that don't from the current AP.
- Add read eeprom_id function for zcom. current only support Airoha 0x10 version

Bug fix:
- Restore calibration file to 1.2.23 version


miniport driver :     	ver.1.2.25.1001
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- Roll back 1.2.19 version calibration file



miniport driver :     	ver.1.2.23.1001
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- fix bug forget update some code at 1.2.17 version


miniport driver :     	ver.1.2.21.1001
-------------------------------
New function:
- No update

Enhance function:
- Enable hardware icv error filter. don't use icv error packet to judge wep key
  error
- Hide region option at inf file
- Merger Andrew code

Bug fix:
- No update




miniport driver :     	ver.1.2.19.1001
-------------------------------
New function:
- No update

Enhance function:
- Delete ZCOM function for antenna

Bug fix:
- Fix the bug of can not send encryption packets when first connect to WEP AP .



miniport driver :     	ver.1.2.17.1001
-------------------------------
New function:
- No update

Enhance function:
- Support DTO when back from standby.

Bug fix:
- Support WEP group key and TKIP/AES pararwise key on WPA mode.



miniport driver :     	ver.1.2.15.1001
-------------------------------
New function:
- No update

Enhance function:
- modify WLAN_MAX_SCAN_BSS_DESC from 15 to 30.

Bug fix:
- Fix the bug that driver fill IEs error
- Fix the bug of can not scan ibss which station create
- Fix the bug of wrong ibss ie length in scan result



Version 1.2.13.1001 (2004-01-16)
-------------------------------
New function:
- No update

Enhance function:
- Fix antenna to 1 for ZCOM

Bug fix:
- Fix the bug that driver fill IEs error(error length)



Version 1.2.11.1001 (2004-01-16)
-------------------------------
New function:
- No update

Enhance function:
- modify WLAN_MAX_SCAN_BSS_DESC from 15 to 30.

Bug fix:
- Fix the bug that driver fill IEs error



Version 1.2.9.5000 (2004-01-16)
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- Fix the bug that driver can't correct ibss beacon


Version 1.2.7.5000 (2004-01-13)
-------------------------------
New function:
- No update

Enhance function:
- Record the msdu rate when send and receive , so when query current rate, will get the real current rate.
- modify WLAN_MAX_SCAN_BSS_DESC from 12 to 15.

Bug fix:
- No update


Version 1.2.5.5000 (2004-12-30)
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- Fix the bug that driver can't report correct WEP KEY error on open system.


Version 1.2.3.5000 (2004-12-30)
-------------------------------
New function:
- No update

Enhance function:
- Record the rate when send and receive , so when query current rate, will get the real current rate.

Bug fix:
- No update



Version 1.2.1.1001 (2004-12-30)
-------------------------------
New function:
- No update

Enhance function:
- Only support Airoha RF
- Report ICV error packet number

Bug fix:
- No update



Version 1.1.99 (2004-12-08)
-------------------------------
New function:
- No update

Enhance function:
- Remove support winbond RF code

Bug fix:
- No update



Version 1.1.97 (2004-11-08)
-------------------------------
New function:
- Add WEP KEY error report(use icv error)

Enhance function:
- Merger Andrew code for RF calibration
- Merger HH code for MTO

Bug fix:
- No update


Version 1.1.95 (2004-11-30)
-------------------------------
New function:
- Records the antenna number when scanning and switch to certain antenna in connection procedure.
- Add burst mode control in inf file.

Enhance function:
- Report disconnection event immediately when radio off
- Always enable MTO even disconnected
- Change the BB register for turn on the TX_VGA_ENB and FIX the channel 14 on MAXIM (from HHchi)
- Turn on/off LED according to radio status

Bug fix:
- Driver doesn't report RSSI using average value.


Version 1.1.93.1000 (2004-11-08)
-------------------------------
New function:
- Merge code from Austin, including add W89CRF242 and change the power level for MAXIM 2829 after switching to a new channel

Enhance function:
- No updated

Bug fix:
- No updated


Version 1.1.91.1000 (2004-11-04)
-------------------------------
New function:
- Add code to support region capabilities query.

Enhance function:
- Apply region code set by upper layer. The driver indicates a disconnection event when it has already connected to an AP.

Bug fix:
- Fix the bug that driver doesn't contain ERP element in beacon within 11g IBSS
- Fix the bug that driver doesn't check channel value in DS parameter set


Version 1.1.89.1000 (2004-11-01)
-------------------------------
New function:
- Pass sorted rates to MTO
- Split original makefile to three files:
  makefile.1000: same as original version, it supports full function of H/W radio control;
	makefile.5000: no H/W radio control in this version;
	makefile.bmer: same as makefile.1000, except for including additional kernel DLL function;
  type "m" at build environment if you want to build all of there projects.

Enhance function:
- No updated

Bug fix:
- No updated


Version 1.1.87.1000 (2004-10-28)
-------------------------------
New function:
- Calculate RSSI, use the average of the RSSI value of last ten frames
- Disable MTO when the driver didn't connect to any network (AP or IBSS)

Enhance function:
- No updated

Bug fix:
- No updated


Version 1.1.85.1000 (2004-10-27)
-------------------------------
New function:
- No updated

Enhance function:
- No updated

Bug fix:
- Sort rate set in beacon ascendingly when start an IBSS


Version 1.1.83.1000 (2004-10-25)
-------------------------------
New function:
- No updated

Enhance function:
- Check radio status accordint to BIT 14 of GPIO0 (from John, it works now)

Bug fix:
- No updated


Version 1.1.81.1000 (2004-10-21)
-------------------------------
New function:
- Add radio modification notification
- Modify tx-deay2 value from 0x00206a37 to 0x00206837 for Airoha RF (from John)

Enhance function:
- Set GPIO0 to 0x1ff before get radio status in initialization (according to John's suggestion, but it seems that it doesn't work fine)

Bug fix:
- No updated


Version 1.1.79.1000 (2004-10-20)
-------------------------------
New function:
- Merge code from John (Add Airoha TX power control code)
- Add radio control interrupt (triggered by pin13)

Enhance function:
- No updated

Bug fix:
- Always set slot time to short in 11a mode (regardless of BSS or IBSS)

Version 1.1.77.1000 (2004-10-15)
-------------------------------
New function:
- Merge code from John

Enhance function:
- No updated

Bug fix:
- Fix the bug that driver selects wrong transmit rate for broadcast/multicast packets within IBSS and MTO enabled.
- Fix the bug that driver can't connect to network with different network type(infrastructure or IBSS).
- Fix the bug that driver can't start an IBSS when the SSID is same as an AP.


Version 1.1.75.1000 (2004-10-12)
-------------------------------
New function:
- Implement radio on/off to driver.
- Add region implementation to driver.
- Add 802.11h channel switch announcement handling to driver.

Enhance function:
- No updated

Bug fix:
- Fix the bug that driver start an IBSS at wrong channel.


Version 1.1.73.1001 (2004-10-9)
-------------------------------
New function:
- Add radio control to inf file.

Enhance function:
- No updated

Bug fix:
- No updated.


Version 1.1.73.1000 (2004-10-08)
-------------------------------
New function:
- No update


Enhance function:
- Merger John's MTO code

Bug fix:
- Fix the bug that drvier query OID_802_11_RSSI error.
- Fix the bug that drvier query OID_LINK_SPEED  error.

Version 1.1.71.1000 (2004-09-30)
-------------------------------
New function:
- Add new interface for GPIO_0 and GPIO_1. Please find 1.1.71.1000 on drv_handle_interrupt.c
-

Enhance function:
- No update

Bug fix:
- Fix the bug that drvier query/set OID_802_11_CONFIGURATION error.


Version 1.1.69.1000 (2004-09-27)
-------------------------------
New function:
- Merge Maxim 2829 TX power control for different channel in different region (from John)
- Add region information to inf file

Enhance function:
- No update

Bug fix:
- No update


Version 1.1.67.1000 (2004-09-23)
-------------------------------
New function:
- The driver can set current channel arbitrarily (through MMI GUI)
- Merge external kernel DLL code to driver (from John), modify makefile.v2 line 35 to enable this function

Enhance function:
- Implement IBSS TX rate selection (select TX rate from DTO and RX packet rate)

Bug fix:
- Fix the bug that driver contains inaccurate rate in probe request frame.
- Fix the bug that driver doesn't update TSC when adding key .


Version 1.1.65.1000 (2004-09-16)
-------------------------------
New function:
- No update

Enhance function:
- In lm_monitor, use allocated memory instead of auto variable (prevent stack overflow).

Bug fix:
- Fix the bug that driver will leak memory when don't receive last fragment.
- Fix the bug that driver always contains 802.11h elements in association request frame.


Version 1.1.63.1000 (2004-09-14)
-------------------------------
New function:
- No update

Enhance function:
- Add support 100 --- 161 channel on debug version miniport driver and DUT application, however, don't use the debug version driver under WZC.

Bug fix:
- No update


Version 1.1.61.1000 (2004-09-10)
-------------------------------
New function:
- No update

Enhance function:
- Merger new DTO code from John's code.

Bug fix:
- Fix the bug that driver set power level error.
- Fix the bug that driver switch channel from 2.4G band to 5G band.

Version 1.1.59.1000 (2004-09-09)
-------------------------------
New function:
- No update

Enhance function:
- Add Japan 11a channel.
- Add 802.11h support.
- Update DUT for 11a channel.

Bug fix:
- Fix the bug that driver can't send packts on 36,40 channel.


Version 1.1.57.1000 (2004-09-02)
-------------------------------
New function:
- Set auto-rate reduction threshold to zero when protection mechanism enabled.

Enhance function:
- Disable burst mode when protection mechanism enabled.

Bug fix:
- Fix the bug that MMI set frequency instead of channel number to driver when starting an IBSS.


Version 1.1.55.1000 (2004-09-01)
-------------------------------
New function:
- No update

Enhance function:
- add new code to support max2829(current code don't send packet on 36,40 channel)
- change channel number to frequence in code. update new version DUT.
- support LED on CB2MPCI board

Bug fix:
- No update


Version 1.1.53.1000 (2004-08-19)
-------------------------------
New function:
- No update

Enhance function:
- Merge new power save code from John

Bug fix:
- Fix the bug that driver miss some NDIS_PACKETs when there's a NDIS_BUFFER is null.


Version 1.1.51.1000 (2004-08-18)
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- Fix the bug that set early beacon according to the beacon period value (90% of beacon period, John's suggestion)

Version 1.1.49.1000 (2004-08-13)
-------------------------------
New function:
- No update

Enhance function:
- Merge new power saving code from John

Bug fix:
- Fix the bug that make sure H/W in wakeup mode when accessing key lookup table


Version 1.1.47.1000 (2004-08-10)
-------------------------------
New function:
- No update

Enhance function:
- Merge new mto code from John
- Update DXX register 0x28 from 0x40000128 to 0x40000528 when using MAXIM RF

-Bug fix:
- No update


Version 1.1.45.1000 (2004-08-06)
-------------------------------
New function:
- No update

Enhance function
- Add MAX2829 code to driver and inf
- Merger new mto code from John
- Add recover code for lost tx_done
- Update new MAC/BB code from Tiger
- add new file for hardware power save(copy from John)

Bug fix:
- No update.


Version 1.1.43.1004 (2004-08-03)
-------------------------------
New function:
- No update

Enhance function
- No update

Bug fix:
- Fix the bug that driver reports unnecessary disconnect event when connect to another AP with different SSID.


Version 1.1.43.1003 (2004-08-03)
-------------------------------
New function:
- No update

Enhance function
- No update

Bug fix:
- Fix the bug that driver use incorrect channel in join when received beacon/probe response frame doesn't include DS parameter set.


Version 1.1.43.1002 (2004-08-03)
-------------------------------
New function:
- No update

Enhance function
- No update

Bug fix:
- Fix the bug that driver don't report disconnection event when received second MIC-failed packet (with Win2k+Funk client)


Version 1.1.43.1001 (2004-08-03)
-------------------------------
New function:
- No update

Enhance function
- Set additional rate to basic rate within protected mode (YM's suggestion)

Bug fix:
- No update



Version 1.1.43.1000 (2004-08-02)
-------------------------------
New function:
- No update

Enhance function
- No update

Bug fix:
- Fix the bug that driver update RX TSC for any CCMP or TKIP packet.
- Fix the bug that driver uses inaccurate countermeasure timeout value(refix 1.1.41.1000 version).


Version 1.1.41.1000 (2004-07-30)
-------------------------------
New function:
- No update

Enhance funct8ion
- No update

Bug fix:
- Fix the bug that driver discard all EAPOL-Start packet. The current version send all EAPOL-Start packet without any encryption.
- Fix the bug that driver uses inaccurate countermeasure timeout value.


Version 1.1.39.1000 (2004-07-28)
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- Fix the bug that driver can connect AP within next 60 seconds When W89C33
  receives two packets with corrupted MIC values within 60 seconds


Version 1.1.37.1000 (2004-07-27)
-------------------------------
New function:
- Enable driver enable/disable watch-dog through registry.
- Finish *Fast* Power Management function. [LA]
  You can enable the function in Advavce page of driver properties.

Enhance function:
- Driver can report RSN capabilities in RSN IE according to beacon or probe response packet send by AP.

Bug fix:
- Fix the bug that driver sets inaccurate data rate set when start an IBSS.


Version 1.1.35.1000 (2004-07-26)
-------------------------------
New function:
- No update


Enhance function:
- Add function that driver send disauth packet when leave a EBSS.
	The function We think already added at befor version. But we can't any code in VSS
- update Watcg-Dog function [LA]

Bug fix:
- Fix the bug that driver is disassociated by Cisco 1230B-A-K9. don't send EAPOL-START, maybe is Cisco's bug
- Fix the bug that driver can't connect AP use FUNK client. assemble beacon packet error.maybe is FUNK's bug
- Fix the bug that driver don't report disconnect indication when receive disassociate packet.


Version 1.1.33.1000 (2004-07-23)
-------------------------------
New function:
- No update

Enhance function:
- No update

Bug fix:
- Fix the bug that driver can't connect WPA AP with multiple (valid or invalid)
  RSN IEs in beacon or probe response.
- Fix the bug that driver report inaccurate antenna number to MMI.


Version 1.1.31.1000 (2004-07-21)
-------------------------------
New function:
- No update

Enhanced function:
- Add function that driver can select correct IBSS channel according to modulation type.

Bug fix:
- Fix netw33.inf bug to support correct TX rate and IBSS channel
- Fix the bug that the driver can't connect next other AP when encryption
    mode same with before AP.
- Fix the bug that the driver can select data TX rate when DTO enabled.
- Fix the bug that the driver can send encrypted packets when start IBSS.



Version 1.1.29.1100 (2004-07-20)
-------------------------------
New function:
- No update

Enhanced function:
- The driver can ignore unrecognized information element ID and don't report to these IEs to NDIS.
- The driver supports Arioha RF calibration.

Bug fix:
- No update


Version 1.1.29.1000 (2004-07-16)
-------------------------------
New function:
- Don't scan when the driver is transmitting data

Enhanced function:
- Disable MTO to change fragment threshold and RTS threshold

Bug fix:
- Fix the bug that the driver can't redo connection procedure when authentication or association failed
- Fix the bug that the driver don't send remaining packets when watch-dog process finished
- Fix the bug that the driver don't set modulation type correctly for maxin 2827/2828 RF
- Fix the bug that the driver set rate incorrectly when the driver can't read rate value from registry
- Fix the bug that the driver don't report accurate rate set when MMI query this information
- Fix the bug that the driver report inaccurate connection status when NDIS want to connect an IBSS
- Fix the bug that the driver change bit(0) in MAC_CTRL register when the driver set SSID, join to a BSS, or start an IBSS
- Fix the bug that the driver don't reset TX DMA when the driver is setting key




Version 1.1.27.1000 (2004-07-05)
-------------------------------
New function:
- Add function to scan, null-function data frame will be used when the driver scanning, this approach prevents Cisco AP() de-authenticate our NIC

Enhanced function:
- Update MTO code from John
- Update inf file, the driver will use the default value if it can't read configuration from registry

Bug fix:
- Fix the bug that the driver send wrong probe request frame when scanning(probe request frame contains incorrect rate set)
- Fix the bug that the driver can't do shared key authentication and no data encryption invoked in infrastructure and independent mode



Version 1.1.25.1000 (2004-07-02)
--------------------------------
New function:
- Add watch dog couter on debug driver and MMI.
-

Enhanced function:
- Enhance driver debug information

Bug fix:
- Fix the bug that the driver get rf type value error from EEPROM.
- Fix the bug that the driver can't connect AP after implement RF calibration function .


Version 1.1.23.1000 (2004-06-30)
--------------------------------
New function:
- Add sme_get_rf_type_from_hardware function to get rf type from EEPROM.
- Add Maxim RF calibration function .

Enhanced function:
- merger DTO from JOHN code

Bug fix:
- Fix the bug that the driver doesn't send OFDM rate when fragment packets
  without protected mode
- Fix the bug that the driver continue join next AP when join first fail
  reduce join timeout from 2000 TU to 500 TU



Version 1.1.21.1000 (2004-06-28)
--------------------------------
New function:
- Add watch dog function to patch hardware bug.
- Add protected function to access internal memory of hardware, like key-lookup
  tabel and beacon template.

Enhanced function:
- No updated

Bug fix:
- Fix the bug that the driver doesn't report correct data on OID_802_11_BSSID
  within IBSS mode
- Fix the bug that the driver doesn't check OID buffer length supported by NDIS
- Fix the bug that the driver can't get IP address when wakeup from standby mode


Version 1.1.19.1000 (2004-06-24)
--------------------------------
New function:
- No updated

Enhanced function:
- Enhance the driver to stop data transmitting during background scan.

Bug fix:
- When OFDM modulation is used for transmitting the pending frame and the
  protection mechanism is enabled, a RTS frame shall be used if the frame has
  a unicast receiver address and if the length of the frame (MPDU) is greater
  than the RTS threshold, otherwise, CTS-to-Self frame shall be used. [#5]
- Fixed the bug that associated to the DLINK DI-774 11a/b/g AP with 11a channel
  and find the driver will be deauthenticated occasionally during background
  scan. [#13]
- Fixed the bug that WinXP built-in GUI cannot connect to AP when WinXP
  without WPA patch installed. [#14]

Version 1.1.17.1000 (2004-06-17)
--------------------------------
New function:
- No updated

Enhanced function:
- Enhanced the driver to auto reconnect AP at connecting.
- Enhanced the driver to send all fragmented MSDUs using highest DSSS rate.
- Change start beacon period of IBSS from 20 TU to 100 TU.
- Change Dxx 0x5C from 0xAA40C000 to 0xAA28C000

Bug fix:
- Fixed the bug that driver start IBSS beacon include RSN when use DUT.
- Fixed the bug that driver can start IBSS include OFDM rate on 2.4GHz.
- Fixed the bug that driver start IBSS use correct BSSID.
- Fixed the bug that driver select the wrong BSSID when start an IBSS.
- Fixed the bug duration of MMPDU set to 0.
- Fixed the bug twice reset hardware when change to D0 status.
- Fixed the bug that driver crash when DTO disable encryption after the WEP
  key has already been set to driver.
- Fixed the bug that driver compose wrong beacon format when the the length
  of supported rate set exceeds 8 bytes.
- Fixed the bug that driver can join to different BSS with same BSSID but
  SSID is different.

Version 1.1.15.1000 (2004-06-10)
--------------------------------
New function:
- send all MMPDUs using lowest TX rate(1Mbps in 11b/g mode and 6Mbps in 11a mode)
- add 802.11g-IBSS mode

Enhanced function:
- No updated

Bug fix:
- select right TX rate when start an IBSS
- select right BSSID when start an IBSS
- Set CWmin according to AP's supported rate set
- report correct channel when within 11a operating mode

Version 1.1.13.1000 (2004-06-10)
--------------------------------
New function:
- add IBSS station aging function

Enhanced function:
- Check valid beacon in driver
- accept different BSS's beacons from same AP with same BSSID
- select rate set according to modulation type

Bug fix:
- disable WEPOn replace NullKey bit in key lookup table

Version 1.1.11.1000 (2004-06-10)
--------------------------------
New function:
- No updated

Enhanced function:
- add burst mode button on MMI

Bug fix:
- disable BSSID checking function when scanning
- fix channel selection bug when scan 11a channel
- use long slot time within IBSS mode
- select correct channel list according to modulation type

Version 1.1.9.1000  (2004-06-01)
--------------------------------
New function:
- No updated

Enhanced function:
- inf support modulation type(802.11b/g, 802.11a, 802.11a/b/g).
- inf support dis/enable and select WOL mode.
- inf support hardware version(FPGA, CUT1 CUT2)
- OID_802_11_NETWORK_TYPES_SUPPORTED, OID_802_11_NETWORK_TYPE_IN_USE support
  DSSS,OFDM24,OFDM5.
- IBSS beacon rate use 1M when 11b/g, use 6M when 11a, use channel to select
  11b/g or 11a mode.
- Probe request TX rate use 1Mps for 11b/g, use 6M for 11a.
- modify countermeasure only use one timer.
- modify duration calculate for fragment packet.

Bug fix:
- judge OUI for RSN/SSN

Version 1.1.5.1000 (2004-05-24)
--------------------------------
New function:
- No updated

Enhanced function:
- Modify some code. Release version don't support IO control since the version.
- Release version drv_reset return NDIS_STATUS_NOT_RESETTABLE.
- Debug version support get/set some hardware value for DUT 1.1.5.1000 version

Bug fix:
- fix IBSS mode send beacon bug when leave from IBSS, but don't cannect any BSS
- fix IBSS mode TKIP/AES TSC of GroupKey update problme.

Version 1.1.3.1001 (2004-05-20)
--------------------------------
** The version only for WPA2 test
New function:
- No updated

Enhanced function:
- No updated

Bug fix:
- lm_scan will record channel if received beacon/probe response frame doesn't
  contain this field (ds parameter set)
- fix a bug when match group cipher suite and it's different to pairwise cipher
  suite.

Version 1.1.3.1000
--------------------------------
** The version only for WPA2 test
New funtion:
- Add the follow IO/CTRL for support WPA2 funtures.
    OID_802_11_PMKID
    OID_802_11_CAPABILITY

Enhanced  funtion:
- Merger LA code to PD50 code (reference John).
- Update makefile.v2 add __WPA2__
- Update OID_802_11_AUTHENTICATION_MODE to support  __WPA2__

Bug fix
- mofidy hal_get_buf_num. The version only support cut2

Version 1.1.1.1000
--------------------------------
New funtion:
- Add _drv_read_rftype_configuration function to get RF type from registry
- Add the follow IO/CTRL for support DUT new funtures.
    IOCTL_WB_802_11_DUT_DTO_AUTO_VALUES
    IOCTL_WB_802_11_DUT_DTO_MANUAL_VALUES
    IOCTL_WB_802_11_DUT_DRIVER_MATCH
    IOCTL_WB_802_11_DUT_PROTECTION_MODE

Enhanced  funtion:
- Merger LA DTO code to PD50 code.
- Update netw33.inf to support different RF type include MAIXM331, MAIXM317,
  RFMD2959.

Bug fix

******************************************************************************
NOTE: The following version only support MAXIM RF 331

Version 1.0.3.1000
--------------------------------
New funtion:
- Add surprise remove code for card bus.

Enhanced  funtion:
- Modify read cxx e1 to b1 to enable burst mode,
- Modify read cxx e2 to b2 to disable burst mode,

Bug fix

Version 20040420
--------------------------------
New funtion:
- Add support OID_802_11_POWER_MODE

Enhanced  funtion:

Bug fix

Version 20040402
--------------------------------
- Merger  La code and Sh code
- Add tx burst mode code.
- Read cxx e1 to enable burst mode,
- Read cxx e2 to disable burst mode,
     use "20040331" to find code

Version 20040130
--------------------------------
- rx_des_num =32 enable rx_empty interrupt
- fix tx_send_packet bug
- fix bug about oid_802_11_add_wep
- modify hal_get_buf_num function

Version 20040114
--------------------------------
- Add rc file for sys
- Modify connect detect timer for beacon period = 500TU
- Add DTO function

Version 20031229
--------------------------------
- Add counter measurement
- Add "hal_join_request_stop"
- Add "hal_ibss_disconnect"
- Add R/W EEPROM/register
- Update device name to 89c33 (NETW32.INF TO NETW33.INF)
- Increase delay time for work after dis/enable Driver
- Fix bug about from open mode to wep mode,
- Fix a spin lock bug for rx procedure.
- Add lm_mto.c ,lm_mto.h to project.
- Change hal_tx_complete return value from void to u32 for mto function.
- Fix bug about hardware receive large packet(>2600);

Version 20031224
--------------------------------
- Fix share key auth mode, write power on procedure.
